import { PersonClass } from '../model/person-class.model';
import { TeacherClass } from '../model/teacher-class.model';
import { NovaRequestConfig, NovaSchemesValues, NovaMetadata, NovaImplicitHeadersOutput } from 'generator-lib-commons-angular6';
import { Observable } from 'rxjs';
import { HttpClient, HttpHeaders } from '@angular/common/http';
/**
 * ------------------------------------------------
 * @author API Rest Generator
 * ------------------------------------------------
 */
export declare class InheritanceexampleapiService {
    private baseURI;
    private http;
    /** Constant - API Version - Key */
    static API_VERSION_KEY: string;
    /** Constant - API Version - Value */
    static API_VERSION_VALUE: string;
    /** Constant - Nova Release - Key */
    static NOVA_RELEASE_KEY: string;
    /** Attribute - Nova Release */
    novaRelease: string;
    constructor(baseURI: string, http: HttpClient);
    getBaseURI(novaScheme: NovaSchemesValues): string;
    getTeachers(novaRequestConfig: NovaRequestConfig, novaMetadata: NovaMetadata): Observable<TeacherClass[]>;
    /**
     * Validate the input novaScheme with the expected for this
     *
     * @param novaRequestConfig with the request configuration
     */
    getTeachersValidateNovaScheme(novaRequestConfig: NovaRequestConfig): void;
    /**
     * The following method get the full URL
     */
    getTeachersFullUrl(novaScheme: NovaSchemesValues): string;
    /**
     * The following method assign every path parameter with the value
     */
    getTeachersPathAssignment(urlWithNovaScheme: string): string;
    /**
     * The following method assign every query parameter with the value
     */
    getTeachersQueryAssignment(): string;
    /**
     * The following method assign every header parameter with the value
     *
     * @throws Error with an occurred exception
     */
    getTeachersHeaderAssignment(novaImplicitHeadersOutput: NovaImplicitHeadersOutput): HttpHeaders;
    /**
     * @param headers 			with the HTTP headers
     * @param outputHeadersMap	with the output headers map
     * @return the HTTP headers
     * @throws Error with an occurred exception
     */
    getTeachersHeaderAssignmentNovaImplicitHeadersOutput(headers: HttpHeaders, outputHeadersMap: Map<string, string[]>): HttpHeaders;
    /**
     * @param key with the key
     * @return true if the input key is duplicated
     */
    getTeachersIsDuplicatedHeaderWithSpecification(key: string): boolean;
    getPeople(novaRequestConfig: NovaRequestConfig, novaMetadata: NovaMetadata): Observable<PersonClass[]>;
    /**
     * Validate the input novaScheme with the expected for this
     *
     * @param novaRequestConfig with the request configuration
     */
    getPeopleValidateNovaScheme(novaRequestConfig: NovaRequestConfig): void;
    /**
     * The following method get the full URL
     */
    getPeopleFullUrl(novaScheme: NovaSchemesValues): string;
    /**
     * The following method assign every path parameter with the value
     */
    getPeoplePathAssignment(urlWithNovaScheme: string): string;
    /**
     * The following method assign every query parameter with the value
     */
    getPeopleQueryAssignment(): string;
    /**
     * The following method assign every header parameter with the value
     *
     * @throws Error with an occurred exception
     */
    getPeopleHeaderAssignment(novaImplicitHeadersOutput: NovaImplicitHeadersOutput): HttpHeaders;
    /**
     * @param headers 			with the HTTP headers
     * @param outputHeadersMap	with the output headers map
     * @return the HTTP headers
     * @throws Error with an occurred exception
     */
    getPeopleHeaderAssignmentNovaImplicitHeadersOutput(headers: HttpHeaders, outputHeadersMap: Map<string, string[]>): HttpHeaders;
    /**
     * @param key with the key
     * @return true if the input key is duplicated
     */
    getPeopleIsDuplicatedHeaderWithSpecification(key: string): boolean;
    /**
     * @param novaRelease with the NOVA release
     */
    setNovaRelease(novaRelease: string): void;
}
